package apis

import (
    "fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LinePreScript struct {
	api.Api
}

// GetPage 获取委托下单脚本记录表列表
// @Summary 获取委托下单脚本记录表列表
// @Description 获取委托下单脚本记录表列表
// @Tags 委托下单脚本记录表
// @Param apiId query int64 false "api用户"
// @Param status query string false "执行状态:0=等待执行,1=执行中,2=执行结束"
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LinePreScript}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-pre-script [get]
// @Security Bearer
func (e LinePreScript) GetPage(c *gin.Context) {
    req := dto.LinePreScriptGetPageReq{}
    s := service.LinePreScript{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LinePreScript, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取委托下单脚本记录表失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取委托下单脚本记录表
// @Summary 获取委托下单脚本记录表
// @Description 获取委托下单脚本记录表
// @Tags 委托下单脚本记录表
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LinePreScript} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-pre-script/{id} [get]
// @Security Bearer
func (e LinePreScript) Get(c *gin.Context) {
	req := dto.LinePreScriptGetReq{}
	s := service.LinePreScript{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LinePreScript

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取委托下单脚本记录表失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// Insert 创建委托下单脚本记录表
// @Summary 创建委托下单脚本记录表
// @Description 创建委托下单脚本记录表
// @Tags 委托下单脚本记录表
// @Accept application/json
// @Product application/json
// @Param data body dto.LinePreScriptInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-pre-script [post]
// @Security Bearer
func (e LinePreScript) Insert(c *gin.Context) {
    req := dto.LinePreScriptInsertReq{}
    s := service.LinePreScript{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建委托下单脚本记录表失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改委托下单脚本记录表
// @Summary 修改委托下单脚本记录表
// @Description 修改委托下单脚本记录表
// @Tags 委托下单脚本记录表
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LinePreScriptUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-pre-script/{id} [put]
// @Security Bearer
func (e LinePreScript) Update(c *gin.Context) {
    req := dto.LinePreScriptUpdateReq{}
    s := service.LinePreScript{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改委托下单脚本记录表失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}

// Delete 删除委托下单脚本记录表
// @Summary 删除委托下单脚本记录表
// @Description 删除委托下单脚本记录表
// @Tags 委托下单脚本记录表
// @Param data body dto.LinePreScriptDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-pre-script [delete]
// @Security Bearer
func (e LinePreScript) Delete(c *gin.Context) {
    s := service.LinePreScript{}
    req := dto.LinePreScriptDeleteReq{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除委托下单脚本记录表失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "删除成功")
}
